
#ifndef HISTORY_FILE_H
#define HISTORY_FILE_H
/*
  (c)2023 Forward Computing and Control Pty. Ltd.
  NSW Australia, www.forward.com.au
  This code is not warranted to be fit for any purpose. You may only use it at your own risk.
  This code may be freely used for both private and commercial use
  Provided this copyright is maintained.
*/
#include "HistoryRecord.h"

extern const size_t BINARY_RECORD_BUFFER_SIZE;
extern BinaryRecordStruct binaryRecordBuffer[];
extern int binaryRecordBufferCount;
extern int binaryRecordBufferIndex;

void initHistory(); // sets debug if #define DEBUG
void initCurrentFileName();
void clearCurrentDateFilename(); // Get the current date filename
const char* getCurrentDateFilename();
// Functions to manage binary record buffer
void addBinaryRecord(const BinaryRecordStruct& record);
void printBinaryRecord(const BinaryRecordStruct& record, Print* outPtr);
unsigned long appendBufferToFile(); // returns number of records written
int getBinaryRecordCount();


BinaryRecordStruct getBinaryRecord(int index);
//bool isNewDay();  // Check if the date has changed since the last file was written

void print_Accumulated_kWh(const Accumulated_kWh_RecordStruct &accResults, Print * outPtr);

const char *getHistoryFileName();
bool initFileSystem(Print * _debugPtr);
bool initFileSystem();
void listRootDir(Print * out);
void printHistoryRecord(const HistoryRecordStruct &historyRecord, Print* out);
bool printDataFile(const char* fileName, Print* outPtr);
bool readDataStream(Stream& input, Print* outPtr = NULL);
#endif
