#ifndef PROCESS_DATA_H
#define PROCESS_DATA_H
#include <Arduino.h>
#include <SafeString.h>
#include "HistoryRecord.h"

extern const float IMPORT_COST_PER_kWhr;// = 0.3674;
extern const float EXPORT_COST_PER_kWhr;// =  -0.050000;  // Note Export_kWhr is a +ve number always
extern const float OFFPEAK_COST_PER_kWhr;// =  0.2189;
extern const float DAILY_CHARGE;// = 1.617;
extern const unsigned long MAX_RECORD_GAP; // = 6000

/**
 * Accumulate the kilowatt-hours from power readings
 * 
 * @param record The binary record containing power measurements
 * @param results The structure to accumulate kWh into
 */
void accumulate_kWh(const BinaryRecordStruct &record, Accumulated_kWh_RecordStruct &results);
void calculateTotalCost(Accumulated_kWh_RecordStruct& accResults);
void processDataInit();
void processData(SafeString &dataLine);
void initAccumulatedKWhRecord(Accumulated_kWh_RecordStruct &results);
void rotateDayHistory();
extern HistoryRecordStruct historyRecord;

#endif
