#ifndef _NTP_H
#define _NTP_H
/*   
   systemTimeUtils.h
   by Matthew Ford,  2021/12/06
   (c)2021 Forward Computing and Control Pty. Ltd.
   NSW, Australia  www.forward.com.au
   This code may be freely used for both private and commerical use.
   Provide this copyright is maintained.
*/

#include <Arduino.h>
#include <SafeString.h>

void showTimeTZ(Print *debugPtr);
void showTimeDebug(Print *debugPtr);
String getCurrentDate_ddmmyyyy();
String getCurrentDate_yyyymmdd();
String getCurrentTime_hhmm(); // returns local time as hh:mm
String getCurrentTime_hhmmss(); // local time as hh:mm:ss
String getUTCTime(); // returns UTC time as hh:mm:ss
String getLocalTime_s(); // local time HH:MM:ss in sec
unsigned int getLocalTime_mins(); // local time of day in mins
unsigned int getLocalTime_sec();
unsigned int getLocalSecLeftInDay();
unsigned int getLocalSecLeftInHr();
const char* tmToChar26(struct tm* timeStruct, char* buffer, size_t bufferSize); // thread safe
SafeString& tm_to_sf(struct tm* tmPtr, SafeString &sf);
void printLocalSystemTime(Print *outPtr);
#endif
